tls-1.4.1: TLS/SSL protocol native implementation (Server and Client)

License | BSD-style
Maintainer | Vincent Hanquez <vincent@snarc.org>
Stability | experimental
Portability | unknown
Safe Haskell | None
Language | Haskell98

Network.TLS

Contents

- Context configuration
- raw types
- Session
- Backend abstraction
- Context object
- Creating a context
- Information gathering
- Credentials
- Initialisation and Termination of context
- Application Layer Protocol Negotiation
- Server Name Indication
- High level API
- Crypto Key
- Compressions & Predefined compressions
- Ciphers & Predefined ciphers
- Versions
- Errors
- Exceptions
- X509 Validation
- X509 Validation Cache
- Key exchange group

Description

Synopsis

- data ClientParams = ClientParams {
  - clientUseMaxFragmentLength :: Maybe MaxFragmentEnum
  - clientServerIdentification :: (HostName, ByteString)
  - clientUseServerNameIndication :: Bool
  - clientWantSessionResume :: Maybe (SessionID, SessionData)
  - clientShared :: Shared
  - clientHooks :: ClientHooks
  - clientSupported :: Supported
  - clientDebug :: DebugParams
  }
- type HostName = String
- type Bytes = ByteString
- data ServerParams = ServerParams {
  - serverWantClientCert :: Bool
  - serverCACertificates :: [SignedCertificate]
  - serverDHEParams :: Maybe DHParams
  - serverShared :: Shared
  - serverHooks :: ServerHooks
  - serverSupported :: Supported
  - serverDebug :: DebugParams
  }
- data DebugParams = DebugParams {
  - debugSeed :: Maybe Seed
  - debugPrintSeed :: Seed -> IO ()
  }
- type DHParams = Params
- type DHPublic = PublicNumber
- data ClientHooks = ClientHooks {
  - onCertificateRequest :: ([CertificateType], Maybe [HashAndSignatureAlgorithm], [DistinguishedName]) -> IO (Maybe (CertificateChain, PrivKey))
  - onServerCertificate :: CertificateStore -> ValidationCache -> ServiceID -> CertificateChain -> IO [FailedReason]
  - onSuggestALPN :: IO (Maybe [ByteString])
  - onCustomFFDHEGroup :: DHParams -> DHPublic -> IO GroupUsage
  }
- data ServerHooks = ServerHooks {
  - onClientCertificate :: CertificateChain -> IO CertificateUsage
  - onUnverifiedClientCert :: IO Bool
  - onCipherChoosing :: Version -> [Cipher] -> Cipher
  - onServerNameIndication :: Maybe HostName -> IO Credentials
  - onNewHandshake :: Measurement -> IO Bool
  - onALPNClientSuggest :: Maybe ([ByteString] -> IO ByteString)
  }
- data Supported = Supported {
  - supportedVersions :: [Version]
  - supportedCiphers :: [Cipher]
  - supportedCompressions :: [Compression]
  - supportedHashSignatures :: [HashAndSignatureAlgorithm]
  - supportedSecureRenegotiation :: Bool
  - supportedClientInitiatedRenegotiation :: Bool
  - supportedSession :: Bool
  - supportedFallbackScsv :: Bool
  - supportedEmptyPacket :: Bool
  - supportedGroups :: [Group]
  }
- data Shared = Shared {
  - sharedCredentials :: Credentials
  - sharedSessionManager :: SessionManager
  - sharedCAStore :: CertificateStore
  - sharedValidationCache :: ValidationCache
  }
- data Hooks = Hooks {
  - hookRecvHandshake :: Handshake -> IO Handshake
  - hookRecvCertificates :: CertificateChain -> IO ()
  - hookLogging :: Logging
  }
- data Handshake
- data Logging = Logging {
  - loggingPacketSent :: String -> IO ()
  - loggingPacketRecv :: String -> IO ()
  - loggingIOSent :: ByteString -> IO ()
  - loggingIORecv :: Header -> ByteString -> IO ()
  }
- data Measurement = Measurement {
  - nbHandshakes :: !Word32
  - bytesReceived :: !Word32
  - bytesSent :: !Word32
  }
- data GroupUsage
  - = GroupUsageValid
  - | GroupUsageInsecure
  - | GroupUsageUnsupported String
  - | GroupUsageInvalidPublic
- data CertificateUsage
  - = CertificateUsageAccept
  - | CertificateUsageReject CertificateRejectReason
- data CertificateRejectReason
  - = CertificateRejectExpired
  - | CertificateRejectRevoked
  - | CertificateRejectUnknownCA
  - | CertificateRejectOther String
- defaultParamsClient :: HostName -> ByteString -> ClientParams
- data MaxFragmentEnum
  - = MaxFragment512
  - | MaxFragment1024
  - | MaxFragment2048
  - | MaxFragment4096
- type HashAndSignatureAlgorithm = (HashAlgorithm, SignatureAlgorithm)
- data HashAlgorithm
  - = HashNone
  - | HashMD5
  - | HashSHA1
  - | HashSHA224
  - | HashSHA256
  - | HashSHA384
  - | HashSHA512
  - | HashIntrinsic
  - | HashOther Word8
- data SignatureAlgorithm
  - = SignatureAnonymous
  - | SignatureRSA
  - | SignatureDSS
  - | SignatureECDSA
  - | SignatureRSApssSHA256
  - | SignatureRSApssSHA384
  - | SignatureRSApssSHA512
  - | SignatureEd25519
  - | SignatureEd448
  - | SignatureOther Word8
- data CertificateType
  - = CertificateType_RSA_Sign
  - | CertificateType_DSS_Sign
  - | CertificateType_RSA_Fixed_DH
  - | CertificateType_DSS_Fixed_DH
  - | CertificateType_RSA_Ephemeral_DH
  - | CertificateType_DSS_Ephemeral_DH
  - | CertificateType_fortezza_dms
  - | CertificateType_Unknown Word8
- data ProtocolType
  - = ProtocolType_ChangeCipherSpec
  - | ProtocolType_Alert
  - | ProtocolType_Handshake
  - | ProtocolType_AppData
  - | ProtocolType_DeprecatedHandshake
- data Header = Header ProtocolType Version Word16
- type SessionID = ByteString
- data SessionData = SessionData {
  - sessionVersion :: Version
  - sessionCipher :: CipherID
  - sessionCompression :: CompressionID
  - sessionClientSNI :: Maybe HostName
  - sessionSecret :: ByteString
  }
- data SessionManager = SessionManager {
  - sessionResume :: SessionID -> IO (Maybe SessionData)
  - sessionEstablish :: SessionID -> SessionData -> IO ()
  - sessionInvalidate :: SessionID -> IO ()
  }
- noSessionManager :: SessionManager
- data Backend = Backend {
  - backendFlush :: IO ()
  - backendClose :: IO ()
  - backendSend :: ByteString -> IO ()
  - backendRecv :: Int -> IO ByteString
  }
- data Context
- ctxConnection :: Context -> Backend
- class TLSParams a
- class HasBackend a where
  - initializeBackend :: a -> IO ()
  - getBackend :: a -> Backend
- contextNew :: (MonadIO m, HasBackend backend, TLSParams params) => backend -> params -> m Context
- contextNewOnHandle :: (MonadIO m, TLSParams params) => Handle -> params -> m Context
- contextNewOnSocket :: (MonadIO m, TLSParams params) => Socket -> params -> m Context
- contextFlush :: Context -> IO ()
- contextClose :: Context -> IO ()
- contextHookSetHandshakeRecv :: Context -> (Handshake -> IO Handshake) -> IO ()
- contextHookSetCertificateRecv :: Context -> (CertificateChain -> IO ()) -> IO ()
- contextHookSetLogging :: Context -> Logging -> IO ()
- contextModifyHooks :: Context -> (Hooks -> Hooks) -> IO ()
- data Information = Information {
  - infoVersion :: Version
  - infoCipher :: Cipher
  - infoCompression :: Compression
  - infoMasterSecret :: Maybe ByteString
  - infoClientRandom :: Maybe ClientRandom
  - infoServerRandom :: Maybe ServerRandom
  }
- data ClientRandom
- data ServerRandom
- unClientRandom :: ClientRandom -> ByteString
- unServerRandom :: ServerRandom -> ByteString
- contextGetInformation :: Context -> IO (Maybe Information)
- newtype Credentials = Credentials [Credential]
- type Credential = (CertificateChain, PrivKey)
- credentialLoadX509 :: FilePath -> FilePath -> IO (Either String Credential)
- credentialLoadX509FromMemory :: ByteString -> ByteString -> Either String Credential
- credentialLoadX509Chain :: FilePath -> [FilePath] -> FilePath -> IO (Either String Credential)
- credentialLoadX509ChainFromMemory :: ByteString -> [ByteString] -> ByteString -> Either String Credential
- bye :: MonadIO m => Context -> m ()
- handshake :: MonadIO m => Context -> m ()
- getNegotiatedProtocol :: MonadIO m => Context -> m (Maybe ByteString)
- getClientSNI :: MonadIO m => Context -> m (Maybe HostName)
- sendData :: MonadIO m => Context -> ByteString -> m ()
- recvData :: MonadIO m => Context -> m ByteString
- recvData' :: MonadIO m => Context -> m ByteString
- data PubKey
  - = PubKeyRSA PublicKey
  - | PubKeyDSA PublicKey
  - | PubKeyDH (Integer, Integer, Integer, Maybe Integer, ([Word8], Integer))
  - | PubKeyEC PubKeyEC
  - | PubKeyX25519 PublicKey
  - | PubKeyX448 PublicKey
  - | PubKeyEd25519 PublicKey
  - | PubKeyEd448 PublicKey
  - | PubKeyUnknown OID ByteString
- data PrivKey
  - = PrivKeyRSA PrivateKey
  - | PrivKeyDSA PrivateKey
  - | PrivKeyEC PrivKeyEC
  - | PrivKeyX25519 SecretKey
  - | PrivKeyX448 SecretKey
  - | PrivKeyEd25519 SecretKey
  - | PrivKeyEd448 SecretKey
- data Compression = CompressionC a => Compression a
- class CompressionC a where
  - compressionCID :: a -> CompressionID
  - compressionCDeflate :: a -> ByteString -> (a, ByteString)
  - compressionCInflate :: a -> ByteString -> (a, ByteString)
- nullCompression :: Compression
- data CipherKeyExchangeType
  - = CipherKeyExchange_RSA
  - | CipherKeyExchange_DH_Anon
  - | CipherKeyExchange_DHE_RSA
  - | CipherKeyExchange_ECDHE_RSA
  - | CipherKeyExchange_DHE_DSS
  - | CipherKeyExchange_DH_DSS
  - | CipherKeyExchange_DH_RSA
  - | CipherKeyExchange_ECDH_ECDSA
  - | CipherKeyExchange_ECDH_RSA
  - | CipherKeyExchange_ECDHE_ECDSA
- data Bulk = Bulk {
  - bulkName :: String
  - bulkKeySize :: Int
  - bulkIVSize :: Int
  - bulkExplicitIV :: Int
  - bulkAuthTagLen :: Int
  - bulkBlockSize :: Int
  - bulkF :: BulkFunctions
  }
- data BulkFunctions
  - = BulkBlockF (BulkDirection -> BulkKey -> BulkBlock)
  - | BulkStreamF (BulkDirection -> BulkKey -> BulkStream)
  - | BulkAeadF (BulkDirection -> BulkKey -> BulkAEAD)
- data BulkDirection
  - = BulkEncrypt
  - | BulkDecrypt
- data BulkState
  - = BulkStateStream BulkStream
  - | BulkStateBlock BulkBlock
  - | BulkStateAEAD BulkAEAD
  - | BulkStateUninitialized
- newtype BulkStream = BulkStream (ByteString -> (ByteString, BulkStream))
- type BulkBlock = BulkIV -> ByteString -> (ByteString, BulkIV)
- type BulkAEAD = BulkNonce -> ByteString -> BulkAdditionalData -> (ByteString, AuthTag)
- bulkInit :: Bulk -> BulkDirection -> BulkKey -> BulkState
- data Hash
  - = MD5
  - | SHA1
  - | SHA224
  - | SHA256
  - | SHA384
  - | SHA512
  - | SHA1_MD5
- data Cipher = Cipher {
  - cipherID :: CipherID
  - cipherName :: String
  - cipherHash :: Hash
  - cipherBulk :: Bulk
  - cipherKeyExchange :: CipherKeyExchangeType
  - cipherMinVer :: Maybe Version
  - cipherPRFHash :: Maybe Hash
  }
- type CipherID = Word16
- cipherKeyBlockSize :: Cipher -> Int
- type BulkKey = ByteString
- type BulkIV = ByteString
- type BulkNonce = ByteString
- type BulkAdditionalData = ByteString
- cipherAllowedForVersion :: Version -> Cipher -> Bool
- cipherExchangeNeedMoreData :: CipherKeyExchangeType -> Bool
- hasMAC :: BulkFunctions -> Bool
- hasRecordIV :: BulkFunctions -> Bool
- data Version
  - = SSL2
  - | SSL3
  - | TLS10
  - | TLS11
  - | TLS12
- data TLSError
  - = Error_Misc String
  - | Error_Protocol (String, Bool, AlertDescription)
  - | Error_Certificate String
  - | Error_HandshakePolicy String
  - | Error_EOF
  - | Error_Packet String
  - | Error_Packet_unexpected String String
  - | Error_Packet_Parsing String
- data KxError
  - = RSAError Error
  - | KxUnsupported
- data AlertDescription
  - = CloseNotify
  - | UnexpectedMessage
  - | BadRecordMac
  - | DecryptionFailed
  - | RecordOverflow
  - | DecompressionFailure
  - | HandshakeFailure
  - | BadCertificate
  - | UnsupportedCertificate
  - | CertificateRevoked
  - | CertificateExpired
  - | CertificateUnknown
  - | IllegalParameter
  - | UnknownCa
  - | AccessDenied
  - | DecodeError
  - | DecryptError
  - | ExportRestriction
  - | ProtocolVersion
  - | InsufficientSecurity
  - | InternalError
  - | InappropriateFallback
  - | UserCanceled
  - | NoRenegotiation
  - | UnsupportedExtension
  - | CertificateUnobtainable
  - | UnrecognizedName
  - | BadCertificateStatusResponse
  - | BadCertificateHashValue
- data TLSException
  - = Terminated Bool String TLSError
  - | HandshakeFailed TLSError
  - | ConnectionNotEstablished
- data ValidationChecks = ValidationChecks {
  - checkTimeValidity :: Bool
  - checkAtTime :: Maybe DateTime
  - checkStrictOrdering :: Bool
  - checkCAConstraints :: Bool
  - checkExhaustive :: Bool
  - checkLeafV3 :: Bool
  - checkLeafKeyUsage :: [ExtKeyUsageFlag]
  - checkLeafKeyPurpose :: [ExtKeyUsagePurpose]
  - checkFQHN :: Bool
  }
- data ValidationHooks = ValidationHooks {
  - hookMatchSubjectIssuer :: DistinguishedName -> Certificate -> Bool
  - hookValidateTime :: DateTime -> Certificate -> [FailedReason]
  - hookValidateName :: HostName -> Certificate -> [FailedReason]
  - hookFilterReason :: [FailedReason] -> [FailedReason]
  }
- data ValidationCache = ValidationCache {
  - cacheQuery :: ValidationCacheQueryCallback
  - cacheAdd :: ValidationCacheAddCallback
  }
- data ValidationCacheResult
  - = ValidationCachePass
  - | ValidationCacheDenied String
  - | ValidationCacheUnknown
- exceptionValidationCache :: [(ServiceID, Fingerprint)] -> ValidationCache
- data Group
  - = P256
  - | P384
  - | P521
  - | X25519
  - | X448
  - | FFDHE2048
  - | FFDHE3072
  - | FFDHE4096
  - | FFDHE6144
  - | FFDHE8192

# Context configuration

data ClientParams Source #

Constructors

ClientParams |

Fields

- clientUseMaxFragmentLength :: Maybe MaxFragmentEnum
- clientServerIdentification :: (HostName, ByteString)

  Define the name of the server, along with an extra service identification blob. this is important that the hostname part is properly filled for security reason, as it allow to properly associate the remote side with the given certificate during a handshake.

  The extra blob is useful to differentiate services running on the same host, but that might have different certificates given. It's only used as part of the X509 validation infrastructure.

- clientUseServerNameIndication :: Bool

  Allow the use of the Server Name Indication TLS extension during handshake, which allow the client to specify which host name, it's trying to access. This is useful to distinguish CNAME aliasing (e.g. web virtual host).

- clientWantSessionResume :: Maybe (SessionID, SessionData)

  try to establish a connection using this session.

- clientShared :: Shared
- clientHooks :: ClientHooks
- clientSupported :: Supported

  In this element, you'll need to override the default empty value of of `supportedCiphers` with a suitable cipherlist.

- clientDebug :: DebugParams

Instances

Show ClientParams Source # |
Instance details Defined in Network.TLS.Parameters Methods showsPrec :: Int -> ClientParams -> ShowS Source # show :: ClientParams -> String Source # showList :: [ClientParams] -> ShowS Source #
TLSParams ClientParams Source # |
Instance details Defined in Network.TLS.Context Methods getTLSCommonParams :: ClientParams -> CommonParams getTLSRole :: ClientParams -> Role doHandshake :: ClientParams -> Context -> IO () doHandshakeWith :: ClientParams -> Context -> Handshake -> IO ()

type HostName = String Source #

type Bytes = ByteString Source #

Deprecated: Use Data.ByteString.Bytestring instead of Bytes.

data ServerParams Source #

Constructors

ServerParams |

Fields

- serverWantClientCert :: Bool

  request a certificate from client.

- serverCACertificates :: [SignedCertificate]

  This is a list of certificates from which the disinguished names are sent in certificate request messages. For TLS1.0, it should not be empty.

- serverDHEParams :: Maybe DHParams

  Server Optional Diffie Hellman parameters. Setting parameters is necessary for FFDHE key exchange when clients are not compatible with RFC 7919.

  Value can be one of the standardized groups from module Network.TLS.Extra.FFDHE or custom parameters generated with `generateParams`.

- serverShared :: Shared
- serverHooks :: ServerHooks
- serverSupported :: Supported
- serverDebug :: DebugParams

Instances

Show ServerParams Source # |
Instance details Defined in Network.TLS.Parameters Methods showsPrec :: Int -> ServerParams -> ShowS Source # show :: ServerParams -> String Source # showList :: [ServerParams] -> ShowS Source #
Default ServerParams Source # |
Instance details Defined in Network.TLS.Parameters Methods def :: ServerParams Source #
TLSParams ServerParams Source # |
Instance details Defined in Network.TLS.Context Methods getTLSCommonParams :: ServerParams -> CommonParams getTLSRole :: ServerParams -> Role doHandshake :: ServerParams -> Context -> IO () doHandshakeWith :: ServerParams -> Context -> Handshake -> IO ()

data DebugParams Source #

All settings should not be used in production

Constructors

DebugParams |

Fields

- debugSeed :: Maybe Seed

  Disable the true randomness in favor of deterministic seed that will produce a deterministic random from. This is useful for tests and debugging purpose. Do not use in production

- debugPrintSeed :: Seed -> IO ()

  Add a way to print the seed that was randomly generated. re-using the same seed will reproduce the same randomness with `debugSeed`

Instances

Show DebugParams Source # |
Instance details Defined in Network.TLS.Parameters Methods showsPrec :: Int -> DebugParams -> ShowS Source # show :: DebugParams -> String Source # showList :: [DebugParams] -> ShowS Source #
Default DebugParams Source # |
Instance details Defined in Network.TLS.Parameters Methods def :: DebugParams Source #

type DHParams = Params Source #

type DHPublic = PublicNumber Source #

data ClientHooks Source #

A set of callbacks run by the clients for various corners of TLS establishment

Constructors

ClientHooks |

Fields

- onCertificateRequest :: ([CertificateType], Maybe [HashAndSignatureAlgorithm], [DistinguishedName]) -> IO (Maybe (CertificateChain, PrivKey))

  This action is called when the server sends a certificate request. The parameter is the information from the request. The action should select a certificate chain of one of the given certificate types where the last certificate in the chain should be signed by one of the given distinguished names. Each certificate should be signed by the following one, except for the last. At least the first of the certificates in the chain must have a corresponding private key, because that is used for signing the certificate verify message.

  Note that is is the responsibility of this action to select a certificate matching one of the requested certificate types. Returning a non-matching one will lead to handshake failure later.

  Returning a certificate chain not matching the distinguished names may lead to problems or not, depending whether the server accepts it.

- onServerCertificate :: CertificateStore -> ValidationCache -> ServiceID -> CertificateChain -> IO [FailedReason]

  Used by the client to validate the server certificate. The default implementation calls `validateDefault` which validates according to the default hooks and checks provided by Data.X509.Validation. This can be replaced with a custom validation function using different settings.

- onSuggestALPN :: IO (Maybe [ByteString])

  This action is called when the client sends ClientHello to determine ALPN values such as '["h2", "http/1.1"]'.

- onCustomFFDHEGroup :: DHParams -> DHPublic -> IO GroupUsage

  This action is called to validate DHE parameters when the server selected a finite-field group not part of the "Supported Groups Registry". See RFC 7919 section 3.1 for recommandations.

Instances

Show ClientHooks Source # |
Instance details Defined in Network.TLS.Parameters Methods showsPrec :: Int -> ClientHooks -> ShowS Source # show :: ClientHooks -> String Source # showList :: [ClientHooks] -> ShowS Source #
Default ClientHooks Source # |
Instance details Defined in Network.TLS.Parameters Methods def :: ClientHooks Source #

data ServerHooks Source #

A set of callbacks run by the server for various corners of the TLS establishment

Constructors

ServerHooks |

Fields

- onClientCertificate :: CertificateChain -> IO CertificateUsage

  This action is called when a client certificate chain is received from the client. When it returns a CertificateUsageReject value, the handshake is aborted.

- onUnverifiedClientCert :: IO Bool

  This action is called when the client certificate cannot be verified. Return `True` to accept the certificate anyway, or `False` to fail verification.

- onCipherChoosing :: Version -> [Cipher] -> Cipher

  Allow the server to choose the cipher relative to the the client version and the client list of ciphers.

  This could be useful with old clients and as a workaround to the BEAST (where RC4 is sometimes prefered with TLS < 1.1)

  The client cipher list cannot be empty.

- onServerNameIndication :: Maybe HostName -> IO Credentials

  Allow the server to indicate additional credentials to be used depending on the host name indicated by the client.

  This is most useful for transparent proxies where credentials must be generated on the fly according to the host the client is trying to connect to.

  Returned credentials may be ignored if a client does not support the signature algorithms used in the certificate chain.

- onNewHandshake :: Measurement -> IO Bool

  at each new handshake, we call this hook to see if we allow handshake to happens.

- onALPNClientSuggest :: Maybe ([ByteString] -> IO ByteString)

  Allow the server to choose an application layer protocol suggested from the client through the ALPN (Application Layer Protocol Negotiation) extensions.

Instances

Show ServerHooks Source # |
Instance details Defined in Network.TLS.Parameters Methods showsPrec :: Int -> ServerHooks -> ShowS Source # show :: ServerHooks -> String Source # showList :: [ServerHooks] -> ShowS Source #
Default ServerHooks Source # |
Instance details Defined in Network.TLS.Parameters Methods def :: ServerHooks Source #

data Supported Source #

List all the supported algorithms, versions, ciphers, etc supported.

Constructors

Supported |

Fields

- supportedVersions :: [Version]

  Supported Versions by this context On the client side, the highest version will be used to establish the connection. On the server side, the highest version that is less or equal than the client version will be chosed.

- supportedCiphers :: [Cipher]

  Supported cipher methods. The default is empty, specify a suitable cipher list. `ciphersuite_default` is often a good choice.

- supportedCompressions :: [Compression]

  supported compressions methods

- supportedHashSignatures :: [HashAndSignatureAlgorithm]

  All supported hash/signature algorithms pair for client certificate verification and server signature in (EC)DHE, ordered by decreasing priority.

  This list is sent to the peer as part of the signature_algorithms extension. It is also used to restrict the choice of server credential, signature and hash algorithm, but only when the TLS version is 1.2 or above. In order to disable SHA-1 one must then also disable earlier protocol versions in `supportedVersions`.

- supportedSecureRenegotiation :: Bool

  Secure renegotiation defined in RFC5746. If `True`, clients send the renegotiation_info extension. If `True`, servers handle the extension or the renegotiation SCSV then send the renegotiation_info extension.

- supportedClientInitiatedRenegotiation :: Bool

  If `True`, renegotiation is allowed from the client side. This is vulnerable to DOS attacks. If `False`, renegotiation is allowed only from the server side via HelloRequest.

- supportedSession :: Bool

  Set if we support session.

- supportedFallbackScsv :: Bool

  Support for fallback SCSV defined in RFC7507. If `True`, servers reject handshakes which suggest a lower protocol than the highest protocol supported.

- supportedEmptyPacket :: Bool

  In ver <= TLS1.0, block ciphers using CBC are using CBC residue as IV, which can be guessed by an attacker. Hence, an empty packet is normally sent before a normal data packet, to prevent guessability. Some Microsoft TLS-based protocol implementations, however, consider these empty packets as a protocol violation and disconnect. If this parameter is `False`, empty packets will never be added, which is less secure, but might help in rare cases.

- supportedGroups :: [Group]

  A list of supported elliptic curves and finite-field groups in the preferred order. The default value is [`X25519`,`P256`,`P384`,`P521`]. `X25519` and `P256` provide 128-bit security which is strong enough until 2030. Both curves are fast because their backends are written in C.

Instances

Eq Supported Source # |
Instance details Defined in Network.TLS.Parameters Methods (==) :: Supported -> Supported -> Bool Source # (/=) :: Supported -> Supported -> Bool Source #
Show Supported Source # |
Instance details Defined in Network.TLS.Parameters Methods showsPrec :: Int -> Supported -> ShowS Source # show :: Supported -> String Source # showList :: [Supported] -> ShowS Source #
Default Supported Source # |
Instance details Defined in Network.TLS.Parameters Methods def :: Supported Source #

data Shared Source #

Constructors

Shared |

Fields

- sharedCredentials :: Credentials
- sharedSessionManager :: SessionManager
- sharedCAStore :: CertificateStore
- sharedValidationCache :: ValidationCache

Instances

Show Shared Source # |
Instance details Defined in Network.TLS.Parameters Methods showsPrec :: Int -> Shared -> ShowS Source # show :: Shared -> String Source # showList :: [Shared] -> ShowS Source #
Default Shared Source # |
Instance details Defined in Network.TLS.Parameters Methods def :: Shared Source #

data Hooks Source #

A collection of hooks actions.

Constructors

Hooks |

Fields

- hookRecvHandshake :: Handshake -> IO Handshake

  called at each handshake message received

- hookRecvCertificates :: CertificateChain -> IO ()

  called at each certificate chain message received

- hookLogging :: Logging

  hooks on IO and packets, receiving and sending.

Instances

Default Hooks Source # |
Instance details Defined in Network.TLS.Hooks Methods def :: Hooks Source #

data Handshake Source #

Instances

Eq Handshake Source # |
Instance details Defined in Network.TLS.Struct Methods (==) :: Handshake -> Handshake -> Bool Source # (/=) :: Handshake -> Handshake -> Bool Source #
Show Handshake Source # |
Instance details Defined in Network.TLS.Struct Methods showsPrec :: Int -> Handshake -> ShowS Source # show :: Handshake -> String Source # showList :: [Handshake] -> ShowS Source #

data Logging Source #

Hooks for logging

This is called when sending and receiving packets and IO

Constructors

Logging |

Fields

- loggingPacketSent :: String -> IO ()
- loggingPacketRecv :: String -> IO ()
- loggingIOSent :: ByteString -> IO ()
- loggingIORecv :: Header -> ByteString -> IO ()

Instances

Default Logging Source # |
Instance details Defined in Network.TLS.Hooks Methods def :: Logging Source #

data Measurement Source #

record some data about this connection.

Constructors

Measurement |

Fields

- nbHandshakes :: !Word32

  number of handshakes on this context

- bytesReceived :: !Word32

  bytes received since last handshake

- bytesSent :: !Word32

  bytes sent since last handshake

Instances

Eq Measurement Source # |
Instance details Defined in Network.TLS.Measurement Methods (==) :: Measurement -> Measurement -> Bool Source # (/=) :: Measurement -> Measurement -> Bool Source #
Show Measurement Source # |
Instance details Defined in Network.TLS.Measurement Methods showsPrec :: Int -> Measurement -> ShowS Source # show :: Measurement -> String Source # showList :: [Measurement] -> ShowS Source #

data GroupUsage Source #

Group usage callback possible return values.

Constructors

GroupUsageValid | usage of group accepted
GroupUsageInsecure | usage of group provides insufficient security
GroupUsageUnsupported String | usage of group rejected for other reason (specified as string)
GroupUsageInvalidPublic | usage of group with an invalid public value

Instances

Eq GroupUsage Source # |
Instance details Defined in Network.TLS.Parameters Methods (==) :: GroupUsage -> GroupUsage -> Bool Source # (/=) :: GroupUsage -> GroupUsage -> Bool Source #
Show GroupUsage Source # |
Instance details Defined in Network.TLS.Parameters Methods showsPrec :: Int -> GroupUsage -> ShowS Source # show :: GroupUsage -> String Source # showList :: [GroupUsage] -> ShowS Source #

data CertificateUsage Source #

Certificate Usage callback possible returns values.

Constructors

CertificateUsageAccept | usage of certificate accepted
CertificateUsageReject CertificateRejectReason | usage of certificate rejected

Instances

Eq CertificateUsage Source # |
Instance details Defined in Network.TLS.X509 Methods (==) :: CertificateUsage -> CertificateUsage -> Bool Source # (/=) :: CertificateUsage -> CertificateUsage -> Bool Source #
Show CertificateUsage Source # |
Instance details Defined in Network.TLS.X509 Methods showsPrec :: Int -> CertificateUsage -> ShowS Source # show :: CertificateUsage -> String Source # showList :: [CertificateUsage] -> ShowS Source #

data CertificateRejectReason Source #

Certificate and Chain rejection reason

Constructors

CertificateRejectExpired |
CertificateRejectRevoked |
CertificateRejectUnknownCA |
CertificateRejectOther String |

Instances

Eq CertificateRejectReason Source # |
Instance details Defined in Network.TLS.X509 Methods (==) :: CertificateRejectReason -> CertificateRejectReason -> Bool Source # (/=) :: CertificateRejectReason -> CertificateRejectReason -> Bool Source #
Show CertificateRejectReason Source # |
Instance details Defined in Network.TLS.X509 Methods showsPrec :: Int -> CertificateRejectReason -> ShowS Source # show :: CertificateRejectReason -> String Source # showList :: [CertificateRejectReason] -> ShowS Source #

defaultParamsClient :: HostName -> ByteString -> ClientParams Source #

data MaxFragmentEnum Source #

Constructors

MaxFragment512 |
MaxFragment1024 |
MaxFragment2048 |
MaxFragment4096 |

Instances

Eq MaxFragmentEnum Source # |
Instance details Defined in Network.TLS.Extension Methods (==) :: MaxFragmentEnum -> MaxFragmentEnum -> Bool Source # (/=) :: MaxFragmentEnum -> MaxFragmentEnum -> Bool Source #
Show MaxFragmentEnum Source # |
Instance details Defined in Network.TLS.Extension Methods showsPrec :: Int -> MaxFragmentEnum -> ShowS Source # show :: MaxFragmentEnum -> String Source # showList :: [MaxFragmentEnum] -> ShowS Source #

type HashAndSignatureAlgorithm = (HashAlgorithm, SignatureAlgorithm) Source #

data HashAlgorithm Source #

Constructors

HashNone |
HashMD5 |
HashSHA1 |
HashSHA224 |
HashSHA256 |
HashSHA384 |
HashSHA512 |
HashIntrinsic |
HashOther Word8 |

Instances

Eq HashAlgorithm Source # |
Instance details Defined in Network.TLS.Struct Methods (==) :: HashAlgorithm -> HashAlgorithm -> Bool Source # (/=) :: HashAlgorithm -> HashAlgorithm -> Bool Source #
Show HashAlgorithm Source # |
Instance details Defined in Network.TLS.Struct Methods showsPrec :: Int -> HashAlgorithm -> ShowS Source # show :: HashAlgorithm -> String Source # showList :: [HashAlgorithm] -> ShowS Source #

data SignatureAlgorithm Source #

Constructors

SignatureAnonymous |
SignatureRSA |
SignatureDSS |
SignatureECDSA |
SignatureRSApssSHA256 |
SignatureRSApssSHA384 |
SignatureRSApssSHA512 |
SignatureEd25519 |
SignatureEd448 |
SignatureOther Word8 |

Instances

Eq SignatureAlgorithm Source # |
Instance details Defined in Network.TLS.Struct Methods (==) :: SignatureAlgorithm -> SignatureAlgorithm -> Bool Source # (/=) :: SignatureAlgorithm -> SignatureAlgorithm -> Bool Source #
Show SignatureAlgorithm Source # |
Instance details Defined in Network.TLS.Struct Methods showsPrec :: Int -> SignatureAlgorithm -> ShowS Source # show :: SignatureAlgorithm -> String Source # showList :: [SignatureAlgorithm] -> ShowS Source #

data CertificateType Source #

Constructors

CertificateType_RSA_Sign |
CertificateType_DSS_Sign |
CertificateType_RSA_Fixed_DH |
CertificateType_DSS_Fixed_DH |
CertificateType_RSA_Ephemeral_DH |
CertificateType_DSS_Ephemeral_DH |
CertificateType_fortezza_dms |
CertificateType_Unknown Word8 |

Instances

Eq CertificateType Source # |
Instance details Defined in Network.TLS.Struct Methods (==) :: CertificateType -> CertificateType -> Bool Source # (/=) :: CertificateType -> CertificateType -> Bool Source #
Show CertificateType Source # |
Instance details Defined in Network.TLS.Struct Methods showsPrec :: Int -> CertificateType -> ShowS Source # show :: CertificateType -> String Source # showList :: [CertificateType] -> ShowS Source #

# raw types

data ProtocolType Source #

Constructors

ProtocolType_ChangeCipherSpec |
ProtocolType_Alert |
ProtocolType_Handshake |
ProtocolType_AppData |
ProtocolType_DeprecatedHandshake |

Instances

Eq ProtocolType Source # |
Instance details Defined in Network.TLS.Struct Methods (==) :: ProtocolType -> ProtocolType -> Bool Source # (/=) :: ProtocolType -> ProtocolType -> Bool Source #
Show ProtocolType Source # |
Instance details Defined in Network.TLS.Struct Methods showsPrec :: Int -> ProtocolType -> ShowS Source # show :: ProtocolType -> String Source # showList :: [ProtocolType] -> ShowS Source #

data Header Source #

Constructors

Header ProtocolType Version Word16 |

Instances

Eq Header Source # |
Instance details Defined in Network.TLS.Struct Methods (==) :: Header -> Header -> Bool Source # (/=) :: Header -> Header -> Bool Source #
Show Header Source # |
Instance details Defined in Network.TLS.Struct Methods showsPrec :: Int -> Header -> ShowS Source # show :: Header -> String Source # showList :: [Header] -> ShowS Source #

# Session

type SessionID = ByteString Source #

A session ID

data SessionData Source #

Session data to resume

Constructors

SessionData |

Fields

- sessionVersion :: Version
- sessionCipher :: CipherID
- sessionCompression :: CompressionID
- sessionClientSNI :: Maybe HostName
- sessionSecret :: ByteString

Instances

Eq SessionData Source # |
Instance details Defined in Network.TLS.Types Methods (==) :: SessionData -> SessionData -> Bool Source # (/=) :: SessionData -> SessionData -> Bool Source #
Show SessionData Source # |
Instance details Defined in Network.TLS.Types Methods showsPrec :: Int -> SessionData -> ShowS Source # show :: SessionData -> String Source # showList :: [SessionData] -> ShowS Source #

data SessionManager Source #

A session manager

Constructors

SessionManager |

Fields

- sessionResume :: SessionID -> IO (Maybe SessionData)

  used on server side to decide whether to resume a client session.

- sessionEstablish :: SessionID -> SessionData -> IO ()

  used when a session is established.

- sessionInvalidate :: SessionID -> IO ()

  used when a session is invalidated.

noSessionManager :: SessionManager Source #

# Backend abstraction

data Backend Source #

Connection IO backend

Constructors

Backend |

Fields

- backendFlush :: IO ()

  Flush the connection sending buffer, if any.

- backendClose :: IO ()

  Close the connection.

- backendSend :: ByteString -> IO ()

  Send a bytestring through the connection.

- backendRecv :: Int -> IO ByteString

  Receive specified number of bytes from the connection.

Instances

HasBackend Backend Source # |
Instance details Defined in Network.TLS.Backend Methods initializeBackend :: Backend -> IO () Source # getBackend :: Backend -> Backend Source #

# Context object

data Context Source #

A TLS Context keep tls specific state, parameters and backend information.

ctxConnection :: Context -> Backend Source #

return the backend object associated with this context

class TLSParams a Source #

Minimal complete definition

getTLSCommonParams, getTLSRole, doHandshake, doHandshakeWith

Instances

TLSParams ServerParams Source # |
Instance details Defined in Network.TLS.Context Methods getTLSCommonParams :: ServerParams -> CommonParams getTLSRole :: ServerParams -> Role doHandshake :: ServerParams -> Context -> IO () doHandshakeWith :: ServerParams -> Context -> Handshake -> IO ()
TLSParams ClientParams Source # |
Instance details Defined in Network.TLS.Context Methods getTLSCommonParams :: ClientParams -> CommonParams getTLSRole :: ClientParams -> Role doHandshake :: ClientParams -> Context -> IO () doHandshakeWith :: ClientParams -> Context -> Handshake -> IO ()

class HasBackend a where Source #

Methods

initializeBackend :: a -> IO () Source #

getBackend :: a -> Backend Source #

Instances

HasBackend Handle Source # |
Instance details Defined in Network.TLS.Backend Methods initializeBackend :: Handle -> IO () Source # getBackend :: Handle -> Backend Source #
HasBackend Socket Source # |
Instance details Defined in Network.TLS.Backend Methods initializeBackend :: Socket -> IO () Source # getBackend :: Socket -> Backend Source #
HasBackend Backend Source # |
Instance details Defined in Network.TLS.Backend Methods initializeBackend :: Backend -> IO () Source # getBackend :: Backend -> Backend Source #

# Creating a context

contextNew Source #

Arguments

:: (MonadIO m, HasBackend backend, TLSParams params) |
=> backend | Backend abstraction with specific method to interact with the connection type.
-> params | Parameters of the context.
-> m Context |

create a new context using the backend and parameters specified.

contextNewOnHandle Source #

Arguments

:: (MonadIO m, TLSParams params) |
=> Handle | Handle of the connection.
-> params | Parameters of the context.
-> m Context |

Deprecated: use contextNew

create a new context on an handle.

contextNewOnSocket Source #

Arguments

:: (MonadIO m, TLSParams params) |
=> Socket | Socket of the connection.
-> params | Parameters of the context.
-> m Context |

Deprecated: use contextNew

create a new context on a socket.

contextFlush :: Context -> IO () Source #

contextClose :: Context -> IO () Source #

contextHookSetHandshakeRecv :: Context -> (Handshake -> IO Handshake) -> IO () Source #

contextHookSetCertificateRecv :: Context -> (CertificateChain -> IO ()) -> IO () Source #

contextHookSetLogging :: Context -> Logging -> IO () Source #

contextModifyHooks :: Context -> (Hooks -> Hooks) -> IO () Source #

# Information gathering

data Information Source #

Information related to a running context, e.g. current cipher

Constructors

Information |

Fields

- infoVersion :: Version
- infoCipher :: Cipher
- infoCompression :: Compression
- infoMasterSecret :: Maybe ByteString
- infoClientRandom :: Maybe ClientRandom
- infoServerRandom :: Maybe ServerRandom

Instances

Eq Information Source # |
Instance details Defined in Network.TLS.Context.Internal Methods (==) :: Information -> Information -> Bool Source # (/=) :: Information -> Information -> Bool Source #
Show Information Source # |
Instance details Defined in Network.TLS.Context.Internal Methods showsPrec :: Int -> Information -> ShowS Source # show :: Information -> String Source # showList :: [Information] -> ShowS Source #

data ClientRandom Source #

Instances

Eq ClientRandom Source # |
Instance details Defined in Network.TLS.Struct Methods (==) :: ClientRandom -> ClientRandom -> Bool Source # (/=) :: ClientRandom -> ClientRandom -> Bool Source #
Show ClientRandom Source # |
Instance details Defined in Network.TLS.Struct Methods showsPrec :: Int -> ClientRandom -> ShowS Source # show :: ClientRandom -> String Source # showList :: [ClientRandom] -> ShowS Source #

data ServerRandom Source #

Instances

Eq ServerRandom Source # |
Instance details Defined in Network.TLS.Struct Methods (==) :: ServerRandom -> ServerRandom -> Bool Source # (/=) :: ServerRandom -> ServerRandom -> Bool Source #
Show ServerRandom Source # |
Instance details Defined in Network.TLS.Struct Methods showsPrec :: Int -> ServerRandom -> ShowS Source # show :: ServerRandom -> String Source # showList :: [ServerRandom] -> ShowS Source #

unClientRandom :: ClientRandom -> ByteString Source #

unServerRandom :: ServerRandom -> ByteString Source #

contextGetInformation :: Context -> IO (Maybe Information) Source #

Information about the current context

# Credentials

newtype Credentials Source #

Constructors

Credentials [Credential] |

Instances

Semigroup Credentials Source # |
Instance details Defined in Network.TLS.Credentials Methods (<>) :: Credentials -> Credentials -> Credentials Source # sconcat :: NonEmpty Credentials -> Credentials Source # stimes :: Integral b => b -> Credentials -> Credentials Source #
Monoid Credentials Source # |
Instance details Defined in Network.TLS.Credentials Methods mempty :: Credentials Source # mappend :: Credentials -> Credentials -> Credentials Source # mconcat :: [Credentials] -> Credentials Source #

type Credential = (CertificateChain, PrivKey) Source #

credentialLoadX509 Source #

Arguments

:: FilePath | public certificate (X.509 format)
-> FilePath | private key associated
-> IO (Either String Credential) |

try to create a new credential object from a public certificate and the associated private key that are stored on the filesystem in PEM format.

credentialLoadX509FromMemory :: ByteString -> ByteString -> Either String Credential Source #

similar to `credentialLoadX509` but take the certificate and private key from memory instead of from the filesystem.

credentialLoadX509Chain Source #

Arguments

:: FilePath | public certificate (X.509 format)
-> [FilePath] | chain certificates (X.509 format)
-> FilePath | private key associated
-> IO (Either String Credential) |

similar to `credentialLoadX509` but also allow specifying chain certificates.

credentialLoadX509ChainFromMemory :: ByteString -> [ByteString] -> ByteString -> Either String Credential Source #

similar to `credentialLoadX509FromMemory` but also allow specifying chain certificates.

# Initialisation and Termination of context

bye :: MonadIO m => Context -> m () Source #

notify the context that this side wants to close connection. this is important that it is called before closing the handle, otherwise the session might not be resumable (for version < TLS1.2).

this doesn't actually close the handle

handshake :: MonadIO m => Context -> m () Source #

Handshake for a new TLS connection This is to be called at the beginning of a connection, and during renegotiation

# Application Layer Protocol Negotiation

getNegotiatedProtocol :: MonadIO m => Context -> m (Maybe ByteString) Source #

If the ALPN extensions have been used, this will return get the protocol agreed upon.

# Server Name Indication

getClientSNI :: MonadIO m => Context -> m (Maybe HostName) Source #

If the Server Name Indication extension has been used, return the hostname specified by the client.

# High level API

sendData :: MonadIO m => Context -> ByteString -> m () Source #

sendData sends a bunch of data. It will automatically chunk data to acceptable packet size

recvData :: MonadIO m => Context -> m ByteString Source #

recvData get data out of Data packet, and automatically renegotiate if a Handshake ClientHello is received

recvData' :: MonadIO m => Context -> m ByteString Source #

Deprecated: use recvData that returns strict bytestring

same as recvData but returns a lazy bytestring.

# Crypto Key

data PubKey Source #

Public key types known and used in X.509

Constructors

PubKeyRSA PublicKey | RSA public key
PubKeyDSA PublicKey | DSA public key
PubKeyDH (Integer, Integer, Integer, Maybe Integer, ([Word8], Integer)) | DH format with (p,g,q,j,(seed,pgenCounter))
PubKeyEC PubKeyEC | EC public key
PubKeyX25519 PublicKey | X25519 public key
PubKeyX448 PublicKey | X448 public key
PubKeyEd25519 PublicKey | Ed25519 public key
PubKeyEd448 PublicKey | Ed448 public key
PubKeyUnknown OID ByteString | unrecognized format

Instances

Eq PubKey |
Instance details Defined in Data.X509.PublicKey Methods (==) :: PubKey -> PubKey -> Bool Source # (/=) :: PubKey -> PubKey -> Bool Source #
Show PubKey |
Instance details Defined in Data.X509.PublicKey Methods showsPrec :: Int -> PubKey -> ShowS Source # show :: PubKey -> String Source # showList :: [PubKey] -> ShowS Source #
ASN1Object PubKey |
Instance details Defined in Data.X509.PublicKey Methods toASN1 :: PubKey -> ASN1S Source # fromASN1 :: [ASN1] -> Either String (PubKey, [ASN1]) Source #

data PrivKey Source #

Private key types known and used in X.509

Constructors

PrivKeyRSA PrivateKey | RSA private key
PrivKeyDSA PrivateKey | DSA private key
PrivKeyEC PrivKeyEC | EC private key
PrivKeyX25519 SecretKey | X25519 private key
PrivKeyX448 SecretKey | X448 private key
PrivKeyEd25519 SecretKey | Ed25519 private key
PrivKeyEd448 SecretKey | Ed448 private key

Instances

Eq PrivKey |
Instance details Defined in Data.X509.PrivateKey Methods (==) :: PrivKey -> PrivKey -> Bool Source # (/=) :: PrivKey -> PrivKey -> Bool Source #
Show PrivKey |
Instance details Defined in Data.X509.PrivateKey Methods showsPrec :: Int -> PrivKey -> ShowS Source # show :: PrivKey -> String Source # showList :: [PrivKey] -> ShowS Source #
ASN1Object PrivKey |
Instance details Defined in Data.X509.PrivateKey Methods toASN1 :: PrivKey -> ASN1S Source # fromASN1 :: [ASN1] -> Either String (PrivKey, [ASN1]) Source #

# Compressions & Predefined compressions

data Compression Source #

every compression need to be wrapped in this, to fit in structure

Constructors

CompressionC a => Compression a |

Instances

Eq Compression Source # |
Instance details Defined in Network.TLS.Compression Methods (==) :: Compression -> Compression -> Bool Source # (/=) :: Compression -> Compression -> Bool Source #
Show Compression Source # |
Instance details Defined in Network.TLS.Compression Methods showsPrec :: Int -> Compression -> ShowS Source # show :: Compression -> String Source # showList :: [Compression] -> ShowS Source #

class CompressionC a where Source #

supported compression algorithms need to be part of this class

Methods

compressionCID :: a -> CompressionID Source #

compressionCDeflate :: a -> ByteString -> (a, ByteString) Source #

compressionCInflate :: a -> ByteString -> (a, ByteString) Source #

nullCompression :: Compression Source #

default null compression

# Ciphers & Predefined ciphers

data CipherKeyExchangeType Source #

Constructors

CipherKeyExchange_RSA |
CipherKeyExchange_DH_Anon |
CipherKeyExchange_DHE_RSA |
CipherKeyExchange_ECDHE_RSA |
CipherKeyExchange_DHE_DSS |
CipherKeyExchange_DH_DSS |
CipherKeyExchange_DH_RSA |
CipherKeyExchange_ECDH_ECDSA |
CipherKeyExchange_ECDH_RSA |
CipherKeyExchange_ECDHE_ECDSA |

Instances

Eq CipherKeyExchangeType Source # |
Instance details Defined in Network.TLS.Cipher Methods (==) :: CipherKeyExchangeType -> CipherKeyExchangeType -> Bool Source # (/=) :: CipherKeyExchangeType -> CipherKeyExchangeType -> Bool Source #
Show CipherKeyExchangeType Source # |
Instance details Defined in Network.TLS.Cipher Methods showsPrec :: Int -> CipherKeyExchangeType -> ShowS Source # show :: CipherKeyExchangeType -> String Source # showList :: [CipherKeyExchangeType] -> ShowS Source #

data Bulk Source #

Constructors

Bulk |

Fields

- bulkName :: String
- bulkKeySize :: Int
- bulkIVSize :: Int
- bulkExplicitIV :: Int
- bulkAuthTagLen :: Int
- bulkBlockSize :: Int
- bulkF :: BulkFunctions

Instances

Eq Bulk Source # |
Instance details Defined in Network.TLS.Cipher Methods (==) :: Bulk -> Bulk -> Bool Source # (/=) :: Bulk -> Bulk -> Bool Source #
Show Bulk Source # |
Instance details Defined in Network.TLS.Cipher Methods showsPrec :: Int -> Bulk -> ShowS Source # show :: Bulk -> String Source # showList :: [Bulk] -> ShowS Source #

data BulkFunctions Source #

Constructors

BulkBlockF (BulkDirection -> BulkKey -> BulkBlock) |
BulkStreamF (BulkDirection -> BulkKey -> BulkStream) |
BulkAeadF (BulkDirection -> BulkKey -> BulkAEAD) |

data BulkDirection Source #

Constructors

BulkEncrypt |
BulkDecrypt |

Instances

Eq BulkDirection Source # |
Instance details Defined in Network.TLS.Cipher Methods (==) :: BulkDirection -> BulkDirection -> Bool Source # (/=) :: BulkDirection -> BulkDirection -> Bool Source #
Show BulkDirection Source # |
Instance details Defined in Network.TLS.Cipher Methods showsPrec :: Int -> BulkDirection -> ShowS Source # show :: BulkDirection -> String Source # showList :: [BulkDirection] -> ShowS Source #

data BulkState Source #

Constructors

BulkStateStream BulkStream |
BulkStateBlock BulkBlock |
BulkStateAEAD BulkAEAD |
BulkStateUninitialized |

Instances

Show BulkState Source # |
Instance details Defined in Network.TLS.Cipher Methods showsPrec :: Int -> BulkState -> ShowS Source # show :: BulkState -> String Source # showList :: [BulkState] -> ShowS Source #

newtype BulkStream Source #

Constructors

BulkStream (ByteString -> (ByteString, BulkStream)) |

type BulkBlock = BulkIV -> ByteString -> (ByteString, BulkIV) Source #

type BulkAEAD = BulkNonce -> ByteString -> BulkAdditionalData -> (ByteString, AuthTag) Source #

bulkInit :: Bulk -> BulkDirection -> BulkKey -> BulkState Source #

data Hash Source #

Constructors

MD5 |
SHA1 |
SHA224 |
SHA256 |
SHA384 |
SHA512 |
SHA1_MD5 |

Instances

Eq Hash Source # |
Instance details Defined in Network.TLS.Crypto Methods (==) :: Hash -> Hash -> Bool Source # (/=) :: Hash -> Hash -> Bool Source #
Show Hash Source # |
Instance details Defined in Network.TLS.Crypto Methods showsPrec :: Int -> Hash -> ShowS Source # show :: Hash -> String Source # showList :: [Hash] -> ShowS Source #

data Cipher Source #

Cipher algorithm

Constructors

Cipher |

Fields

- cipherID :: CipherID
- cipherName :: String
- cipherHash :: Hash
- cipherBulk :: Bulk
- cipherKeyExchange :: CipherKeyExchangeType
- cipherMinVer :: Maybe Version
- cipherPRFHash :: Maybe Hash

Instances

Eq Cipher Source # |
Instance details Defined in Network.TLS.Cipher Methods (==) :: Cipher -> Cipher -> Bool Source # (/=) :: Cipher -> Cipher -> Bool Source #
Show Cipher Source # |
Instance details Defined in Network.TLS.Cipher Methods showsPrec :: Int -> Cipher -> ShowS Source # show :: Cipher -> String Source # showList :: [Cipher] -> ShowS Source #

type CipherID = Word16 Source #

Cipher identification

cipherKeyBlockSize :: Cipher -> Int Source #

type BulkKey = ByteString Source #

type BulkIV = ByteString Source #

type BulkNonce = ByteString Source #

type BulkAdditionalData = ByteString Source #

cipherAllowedForVersion :: Version -> Cipher -> Bool Source #

Check if a specific `Cipher` is allowed to be used with the version specified

cipherExchangeNeedMoreData :: CipherKeyExchangeType -> Bool Source #

hasMAC :: BulkFunctions -> Bool Source #

hasRecordIV :: BulkFunctions -> Bool Source #

# Versions

data Version Source #

Versions known to TLS

SSL2 is just defined, but this version is and will not be supported.

Constructors

SSL2 |
SSL3 |
TLS10 |
TLS11 |
TLS12 |

Instances

Bounded Version Source # |
Instance details Defined in Network.TLS.Types Methods minBound :: Version Source # maxBound :: Version Source #
Eq Version Source # |
Instance details Defined in Network.TLS.Types Methods (==) :: Version -> Version -> Bool Source # (/=) :: Version -> Version -> Bool Source #
Ord Version Source # |
Instance details Defined in Network.TLS.Types Methods compare :: Version -> Version -> Ordering Source # (<) :: Version -> Version -> Bool Source # (<=) :: Version -> Version -> Bool Source # (>) :: Version -> Version -> Bool Source # (>=) :: Version -> Version -> Bool Source # max :: Version -> Version -> Version Source # min :: Version -> Version -> Version Source #
Show Version Source # |
Instance details Defined in Network.TLS.Types Methods showsPrec :: Int -> Version -> ShowS Source # show :: Version -> String Source # showList :: [Version] -> ShowS Source #

# Errors

data TLSError Source #

TLSError that might be returned through the TLS stack

Constructors

Error_Misc String | mainly for instance of Error
Error_Protocol (String, Bool, AlertDescription) |
Error_Certificate String |
Error_HandshakePolicy String | handshake policy failed.
Error_EOF |
Error_Packet String |
Error_Packet_unexpected String String |
Error_Packet_Parsing String |

Instances

Eq TLSError Source # |
Instance details Defined in Network.TLS.Struct Methods (==) :: TLSError -> TLSError -> Bool Source # (/=) :: TLSError -> TLSError -> Bool Source #
Show TLSError Source # |
Instance details Defined in Network.TLS.Struct Methods showsPrec :: Int -> TLSError -> ShowS Source # show :: TLSError -> String Source # showList :: [TLSError] -> ShowS Source #
Exception TLSError Source # |
Instance details Defined in Network.TLS.Struct Methods toException :: TLSError -> SomeException Source # fromException :: SomeException -> Maybe TLSError Source # displayException :: TLSError -> String Source #

data KxError Source #

Constructors

RSAError Error |
KxUnsupported |

Instances

Show KxError Source # |
Instance details Defined in Network.TLS.Crypto Methods showsPrec :: Int -> KxError -> ShowS Source # show :: KxError -> String Source # showList :: [KxError] -> ShowS Source #

data AlertDescription Source #

Constructors

CloseNotify |
UnexpectedMessage |
BadRecordMac |
DecryptionFailed | deprecated alert, should never be sent by compliant implementation
RecordOverflow |
DecompressionFailure |
HandshakeFailure |
BadCertificate |
UnsupportedCertificate |
CertificateRevoked |
CertificateExpired |
CertificateUnknown |
IllegalParameter |
UnknownCa |
AccessDenied |
DecodeError |
DecryptError |
ExportRestriction |
ProtocolVersion |
InsufficientSecurity |
InternalError |
InappropriateFallback |
UserCanceled |
NoRenegotiation |
UnsupportedExtension |
CertificateUnobtainable |
UnrecognizedName |
BadCertificateStatusResponse |
BadCertificateHashValue |

Instances

Eq AlertDescription Source # |
Instance details Defined in Network.TLS.Struct Methods (==) :: AlertDescription -> AlertDescription -> Bool Source # (/=) :: AlertDescription -> AlertDescription -> Bool Source #
Show AlertDescription Source # |
Instance details Defined in Network.TLS.Struct Methods showsPrec :: Int -> AlertDescription -> ShowS Source # show :: AlertDescription -> String Source # showList :: [AlertDescription] -> ShowS Source #

# Exceptions

data TLSException Source #

TLS Exceptions related to bad user usage or asynchronous errors

Constructors

Terminated Bool String TLSError | Early termination exception with the reason and the error associated
HandshakeFailed TLSError | Handshake failed for the reason attached
ConnectionNotEstablished | Usage error when the connection has not been established and the user is trying to send or receive data

Instances

Eq TLSException Source # |
Instance details Defined in Network.TLS.Struct Methods (==) :: TLSException -> TLSException -> Bool Source # (/=) :: TLSException -> TLSException -> Bool Source #
Show TLSException Source # |
Instance details Defined in Network.TLS.Struct Methods showsPrec :: Int -> TLSException -> ShowS Source # show :: TLSException -> String Source # showList :: [TLSException] -> ShowS Source #
Exception TLSException Source # |
Instance details Defined in Network.TLS.Struct Methods toException :: TLSException -> SomeException Source # fromException :: SomeException -> Maybe TLSException Source # displayException :: TLSException -> String Source #

# X509 Validation

data ValidationChecks Source #

A set of checks to activate or parametrize to perform on certificates.

It's recommended to use `defaultChecks` to create the structure, to better cope with future changes or expansion of the structure.

Constructors

ValidationChecks |

Fields

- checkTimeValidity :: Bool

  check time validity of every certificate in the chain. the make sure that current time is between each validity bounds in the certificate

- checkAtTime :: Maybe DateTime

  The time when the validity check happens. When set to Nothing, the current time will be used

- checkStrictOrdering :: Bool

  Check that no certificate is included that shouldn't be included. unfortunately despite the specification violation, a lots of real world server serves useless and usually old certificates that are not relevant to the certificate sent, in their chain.

- checkCAConstraints :: Bool

  Check that signing certificate got the CA basic constraint. this is absolutely not recommended to turn it off.

- checkExhaustive :: Bool

  Check the whole certificate chain without stopping at the first failure. Allow gathering a exhaustive list of failure reasons. if this is turn off, it's absolutely not safe to ignore a failed reason even it doesn't look serious (e.g. Expired) as other more serious checks would not have been performed.

- checkLeafV3 :: Bool

  Check that the leaf certificate is version 3. If disable, version 2 certificate is authorized in leaf position and key usage cannot be checked.

- checkLeafKeyUsage :: [ExtKeyUsageFlag]

  Check that the leaf certificate is authorized to be used for certain usage. If set to empty list no check are performed, otherwise all the flags is the list need to exists in the key usage extension. If the extension is not present, the check will pass and behave as if the certificate key is not restricted to any specific usage.

- checkLeafKeyPurpose :: [ExtKeyUsagePurpose]

  Check that the leaf certificate is authorized to be used for certain purpose. If set to empty list no check are performed, otherwise all the flags is the list need to exists in the extended key usage extension if present. If the extension is not present, then the check will pass and behave as if the certificate is not restricted to any specific purpose.

- checkFQHN :: Bool

  Check the top certificate names matching the fully qualified hostname (FQHN). it's not recommended to turn this check off, if no other name checks are performed.

Instances

Eq ValidationChecks |
Instance details Defined in Data.X509.Validation Methods (==) :: ValidationChecks -> ValidationChecks -> Bool Source # (/=) :: ValidationChecks -> ValidationChecks -> Bool Source #
Show ValidationChecks |
Instance details Defined in Data.X509.Validation Methods showsPrec :: Int -> ValidationChecks -> ShowS Source # show :: ValidationChecks -> String Source # showList :: [ValidationChecks] -> ShowS Source #
Default ValidationChecks |
Instance details Defined in Data.X509.Validation Methods def :: ValidationChecks Source #

data ValidationHooks Source #

A set of hooks to manipulate the way the verification works.

BEWARE, it's easy to change behavior leading to compromised security.

Constructors

ValidationHooks |

Fields

- hookMatchSubjectIssuer :: DistinguishedName -> Certificate -> Bool

  check whether a given issuer `DistinguishedName` matches the subject `DistinguishedName` of a candidate issuer certificate.

- hookValidateTime :: DateTime -> Certificate -> [FailedReason]

  check whether the certificate in the second argument is valid at the time provided in the first argument. Return an empty list for success or else one or more failure reasons.

- hookValidateName :: HostName -> Certificate -> [FailedReason]

  validate the certificate leaf name with the DNS named used to connect

- hookFilterReason :: [FailedReason] -> [FailedReason]

  user filter to modify the list of failure reasons

Instances

Default ValidationHooks |
Instance details Defined in Data.X509.Validation Methods def :: ValidationHooks Source #

# X509 Validation Cache

data ValidationCache Source #

All the callbacks needed for querying and adding to the cache.

Constructors

ValidationCache |

Fields

- cacheQuery :: ValidationCacheQueryCallback

  cache querying callback

- cacheAdd :: ValidationCacheAddCallback

  cache adding callback

Instances

Default ValidationCache |
Instance details Defined in Data.X509.Validation.Cache Methods def :: ValidationCache Source #

data ValidationCacheResult Source #

The result of a cache query

Constructors

ValidationCachePass | cache allow this fingerprint to go through
ValidationCacheDenied String | cache denied this fingerprint for further validation
ValidationCacheUnknown | unknown fingerprint in cache

Instances

Eq ValidationCacheResult |
Instance details Defined in Data.X509.Validation.Cache Methods (==) :: ValidationCacheResult -> ValidationCacheResult -> Bool Source # (/=) :: ValidationCacheResult -> ValidationCacheResult -> Bool Source #
Show ValidationCacheResult |
Instance details Defined in Data.X509.Validation.Cache Methods showsPrec :: Int -> ValidationCacheResult -> ShowS Source # show :: ValidationCacheResult -> String Source # showList :: [ValidationCacheResult] -> ShowS Source #

exceptionValidationCache :: [(ServiceID, Fingerprint)] -> ValidationCache Source #

create a simple constant cache that list exceptions to the certification validation. Typically this is use to allow self-signed certificates for specific use, with out-of-bounds user checks.

No fingerprints will be added after the instance is created.

The underlying structure for the check is kept as a list, as usually the exception list will be short, but when the list go above a dozen exceptions it's recommended to use another cache mechanism with a faster lookup mechanism (hashtable, map, etc).

Note that only one fingerprint is allowed per ServiceID, for other use, another cache mechanism need to be use.

# Key exchange group

data Group Source #

Constructors

P256 |
P384 |
P521 |
X25519 |
X448 |
FFDHE2048 |
FFDHE3072 |
FFDHE4096 |
FFDHE6144 |
FFDHE8192 |

Instances

Eq Group Source # |
Instance details Defined in Network.TLS.Crypto.Types Methods (==) :: Group -> Group -> Bool Source # (/=) :: Group -> Group -> Bool Source #
Show Group Source # |
Instance details Defined in Network.TLS.Crypto.Types Methods showsPrec :: Int -> Group -> ShowS Source # show :: Group -> String Source # showList :: [Group] -> ShowS Source #